require "import"
import "android.app.Activity"
import "android.content.Context"
import "android.content.Intent"
import "android.net.Uri"
import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.tts.TextToSpeech"

Tsukuyomi = TextToSpeech(service, TextToSpeech.OnInitListener{
  onInit = function(NR_sensey)
    if NR_sensey == TextToSpeech.SUCCESS then
      Tsukuyomi.setLanguage(Locale.getDefault())
    end
  end
})

function LVT(GenjiMonogatari)
  if Tsukuyomi then
    Tsukuyomi.speak(GenjiMonogatari, TextToSpeech.QUEUE_FLUSH, nil, nil)
    end
end


local activity = this

service.playSoundTick()
function startVoiceRecognition(activity)
    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "vi") -- Ngôn ngữ tiếng Việt

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
        end,
        onResults = function(params)
service.playSoundTick()
service.playSoundClock()
            local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            local query = results.get(0)
LVT("Showing search results for: " .. query)
            local url = 'https://play.google.com/store/search?q=' .. query .. '&c=apps'
            local intent = Intent(Intent.ACTION_VIEW)
            intent.setData(Uri.parse(url))
            activity.startActivity(Intent.createChooser(intent, 'Mở bằng:'))
        end,
        onError = function(error)
service.playSoundClock()
LVT("Speak recognition error. Please try again")
        end,
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
end

startVoiceRecognition(activity)

function onCreate(savedInstanceState)
    activity.setTitle("Search for app on play store by voice")
end
